import Qt 4.7
import "../Inspector"

Rectangle {
    id: itemView
    width: Math.ceil(300 * scaleFactor)
    height: Math.ceil(40 * scaleFactor)
    //anchors.fill: parent
    focus: false

    color: "green"
    border.width: 0
    border.color: "green"

    property real scaleFactor : qtScaleFactor
    property string platform : qtPlatformID

    property string itemTitle : qtItemTitle
    property bool itemCompleted: qtItemCompleted
    property string itemUID : qtItemUID
    property string itemProjectUID: qtItemProjectUID
    property string itemSuperUID: qtItemSuperUID
    property string itemType: qtItemType
    property int itemAIDType: qtItemAIDType
    property int itemAttachmentCount: qtItemAttachmentCount
    property bool itemHasNote: qtItemHasNote
    property string itemNote: qtItemNote
    property int itemBackgroundColor: qtItemBackgroundColor
    property int itemStatus: qtItemStatus
    property int itemRunstatus: qtItemRunstatus
    property int itemProgress: qtItemProgress
    property string itemDuration: qtItemDuration
    property string itemReviewDTS: qtInputDTSReview
    property string itemStartDTS: qtInputDTSStart
    property string itemEndDTS: qtInputDTSEnd

    property int layoutFontSize: 14
    property string layoutFontName: "Helvetica"
    property int layoutFontWeight: 25

    property int layoutNoteFontSize: (itemView.platform == "WIN") ? 11 : 11
    property int layoutNoteScaledFontSize: (itemView.platform == "WIN") ? 11 : 11
    property string layoutNoteFontName: "Helvetica"
    property int layoutNoteFontWeight: 25

    property int layoutFooterFontSize: (itemView.platform == "WIN") ? 10 : 11
    property int layoutFooterScaledFontSize: (itemView.platform == "WIN") ? 10 : 11
    property string layoutFooterFontName: "Helvetica"
    property int layoutFooterFontWeight: 25

    property int layoutBorderWidth: 1

    property bool layoutExpanded: qtLayoutExpanded
    property int layoutDisplayNotePreviewLines: qtLayoutDisplayNotePreviewLines
    property int titleHeight: 14

    property bool isSelected : false
    property bool isModified: false
    property bool isEditable: true
    property bool isEditing: false

    property alias mouseAreaVisible: itemTitleInput.mouseAreaVisible
    property alias itemMouseAreaVisible: itemMouseArea.visible

    property int backgroundRadius: 0

    property real gradientStop1: 0.2
    property real gradientStop2: 0.8

    property color backgroundColor: "#d9d9d9"
    property color specialColor: "#333333"
    property color backgroundColorCC1: "#dfdf7c"
    property color backgroundColorCC2: "#df0b16"
    property color backgroundColorCC3: "#af7129"
    property color backgroundColorCC4: "#92df13"
    property color backgroundColorCC5: "#3691df"
    property color backgroundColorCC6: "#de81d7"
    property color backgroundColorCC7: "#b35fdf"

    property Gradient noGradient: Gradient {
        GradientStop { position: 0.0; color: "#00000000" }
    }

    property Gradient backgroundGradient: Gradient {
        GradientStop { position: 0.0; color: "#f3f3f3" }
        //        GradientStop { position: gradientStop1; color: "#c5c5c5" }
        //        GradientStop { position: gradientStop2; color: "#c5c5c5" }
        GradientStop { position: 1.0; color: "#d9d9d9" }
    }

    property Gradient specialGradient: Gradient {
        GradientStop { position: 0.0; color: "#555555" }
        //        GradientStop { position: gradientStop1; color: "#444444" }
        //        GradientStop { position: gradientStop2; color: "#444444" }
        GradientStop { position: 1.0; color: "#333333" }
    }

    property Gradient backgroundGradientCC1: Gradient {
        GradientStop { position: 0.0; color: "#ffffbb" }
        GradientStop { position: gradientStop1; color: "#ffff9c" }
        GradientStop { position: gradientStop2; color: "#ffff9c" }
        GradientStop { position: 1.0; color: "#dfdf7c" }
    }
    property Gradient backgroundGradientCC2: Gradient {
        GradientStop { position: 0.0; color: "#ff4a55" }
        GradientStop { position: gradientStop1; color: "#ff2b36" }
        GradientStop { position: gradientStop2; color: "#ff2b36" }
        GradientStop { position: 1.0; color: "#df0b16" }
    }
    property Gradient backgroundGradientCC3: Gradient {
        GradientStop { position: 0.0; color: "#eeb068" }
        GradientStop { position: gradientStop1; color: "#ce9048" }
        GradientStop { position: gradientStop2; color: "#ce9048" }
        GradientStop { position: 1.0; color: "#af7129" }
    }
    property Gradient backgroundGradientCC4: Gradient {
        GradientStop { position: 0.0; color: "#d1ff52" }
        GradientStop { position: gradientStop1; color: "#b2ff33" }
        GradientStop { position: gradientStop2; color: "#b2ff33" }
        GradientStop { position: 1.0; color: "#92df13" }
    }
    property Gradient backgroundGradientCC5: Gradient {
        GradientStop { position: 0.0; color: "#75d0ff" }
        GradientStop { position: gradientStop1; color: "#56b1ff" }
        GradientStop { position: gradientStop2; color: "#56b1ff" }
        GradientStop { position: 1.0; color: "#3691df" }
    }
    property Gradient backgroundGradientCC6: Gradient {
        GradientStop { position: 0.0; color: "#ffc2ff" }
        GradientStop { position: gradientStop1; color: "#ffa2f8" }
        GradientStop { position: gradientStop2; color: "#ffa2f8" }
        GradientStop { position: 1.0; color: "#de81d7" }
    }
    property Gradient backgroundGradientCC7: Gradient {
        GradientStop { position: 0.0; color: "#f29eff" }
        GradientStop { position: gradientStop1; color: "#d37fff" }
        GradientStop { position: gradientStop2; color: "#d37fff" }
        GradientStop { position: 1.0; color: "#b35fdf" }
    }

    function enableEditMode() {
        isEditable = true
    }

    function disableEditMode() {
        isEditable = false
    }

    function initFromDefaults() {
    }

    function setTitle(title) {
        //console.debug("QML++ setTitle")

        itemTitleInput.defaultText = title;
        itemTitle = title;
    }

    function setStatus(status) {
        //console.debug("QML++ setStatus")

        itemView.itemStatus = status;
    }

    function setRunstatus(runstatus) {
        //console.debug("QML++ setRunstatus")

        itemView.itemRunstatus = runstatus;
    }

    function select() {
        //console.debug("QML++ select")

        isSelected = true;
    }

    function deselect() {
        //console.debug("QML++ deselect")

        itemTitleInput.deactivateControl();

        isSelected = false;
    }

    function setLayout(fontName, fontSize, fontWeight) {
        itemView.layoutFontName = fontName;
        itemView.layoutFontSize = Math.ceil(fontSize * scaleFactor);
        itemView.layoutFontWeight = fontWeight

        //itemView.height = Math.ceil(itemView.layoutFontSize + 16);

        itemView.titleHeight = Math.ceil(itemView.layoutFontSize + 16);

        if (layoutExpanded) {
            itemView.layoutNoteScaledFontSize = Math.ceil(itemView.layoutNoteFontSize * scaleFactor);
            itemView.layoutFooterScaledFontSize = Math.ceil(itemView.layoutFooterFontSize * scaleFactor);
            if (itemView.layoutFooterScaledFontSize > itemView.layoutFooterFontSize) itemView.layoutFooterScaledFontSize = itemView.layoutFooterFontSize;

            itemView.height = itemView.titleHeight + 40 + (itemView.layoutNoteScaledFontSize * itemView.layoutDisplayNotePreviewLines);
            if (itemView.platform == "WIN") itemView.height += 5;

        } else itemView.height = itemView.titleHeight

        loadBackgroundColor();
    }

    onItemBackgroundColorChanged: loadBackgroundColor();

    function loadBackgroundColor() {
        // assign background color / gradient
        if (itemView.platform == "MAC") {
            if (itemView.itemType == "") {
                if (itemView.itemBackgroundColor == 1) background.gradient = itemView.backgroundGradientCC1;
                else if (itemView.itemBackgroundColor == 2) background.gradient = itemView.backgroundGradientCC2;
                else if (itemView.itemBackgroundColor == 3) background.gradient = itemView.backgroundGradientCC3;
                else if (itemView.itemBackgroundColor == 4) background.gradient = itemView.backgroundGradientCC4;
                else if (itemView.itemBackgroundColor == 5) background.gradient = itemView.backgroundGradientCC5;
                else if (itemView.itemBackgroundColor == 6) background.gradient = itemView.backgroundGradientCC6;
                else if (itemView.itemBackgroundColor == 7) background.gradient = itemView.backgroundGradientCC7;
                else background.gradient = itemView.backgroundGradient
            } else background.gradient = itemView.specialGradient;

            if (itemView.layoutExpanded) contentArea.gradient = background.gradient

        } else {
            if (itemView.itemType == "") {
                if (itemView.itemBackgroundColor == 1) background.color = itemView.backgroundColorCC1;
                else if (itemView.itemBackgroundColor == 2) background.color = itemView.backgroundColorCC2;
                else if (itemView.itemBackgroundColor == 3) background.color = itemView.backgroundColorCC3;
                else if (itemView.itemBackgroundColor == 4) background.color = itemView.backgroundColorCC4;
                else if (itemView.itemBackgroundColor == 5) background.color = itemView.backgroundColorCC5;
                else if (itemView.itemBackgroundColor == 6) background.color = itemView.backgroundColorCC6;
                else if (itemView.itemBackgroundColor == 7) background.color = itemView.backgroundColorCC7;
                else background.color = itemView.backgroundColor
            } else background.color = itemView.specialColor;

            if (itemView.layoutExpanded) contentArea.color = background.color
        }

    }

    function startEdit() {
        //console.debug("QML++++++++ startEdit()")
        itemTitleInput.setFocus();
    }

    function endEdit(success) {
        //console.debug("QML++++++++ endEdit()")

        if (success) {
            console.debug("SAVE:" + itemTitleInput.text + " (" + itemTitleInput.defaultText + ")")
            if (itemTitleInput.defaultText !== itemTitleInput.text) {
                if (itemView.itemType === "") QtHandler.dataChanged(itemView.itemType, itemView.itemUID, "name", itemTitleInput.text)
                else QtHandler.dataChanged(itemView.itemType, itemView.itemProjectUID, "name", itemTitleInput.text)
            }

        } else {
            //console.debug("REVERT")
            itemTitleInput.text = itemTitleInput.defaultText
        }

        itemTitleInput.deactivateControl()
        itemView.isEditing = false
    }

    Rectangle {
        id: widgetFrame
        anchors.fill: parent

        color: "orange"
        border.width: 0

        Rectangle {
            id: background
            opacity: (itemView.itemCompleted) ? 0.7 : 1.0

            radius: itemView.backgroundRadius
            anchors.fill: parent
            anchors.bottomMargin: layoutExpanded ? itemView.height - itemView.titleHeight : 0

            border.width: itemView.layoutBorderWidth
            border.color: "black"
            smooth: false

            //
            // Item Message
            //

            MouseArea {
                id: itemMouseArea
                anchors.fill: parent
                acceptedButtons: Qt.LeftButton

                enabled: visible

                onClicked: {
                    //console.debug("ItemViewBasic onClicked itemMouseArea")
                }

                onPressed: {
                    //console.debug("ItemViewBasic onPressed itemMouseArea")

                    if (!itemView.isSelected) {
                        itemView.isSelected = true;
                        QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);

                        //itemTitleInput.setFocus()
                        //itemTitleInput.activateControl(true);

                    } else {
                        //itemTitleInput.setFocus()
                        itemTitleInput.activateControl(true);
                    }
                }
            }

            Image {
                id: itemCompletedImage
                source: {
                    if (itemView.itemCompleted) return "qrc:/icons2/ActionCheckboxOn.png"
                    else return "qrc:/icons2/ActionCheckboxOff.png"
                }
                smooth: false

                anchors.verticalCenter: parent.verticalCenter
                anchors.verticalCenterOffset: -1
                anchors.left: parent.left
                anchors.leftMargin: 5

                visible: (itemView.itemType == "")

                MouseArea {
                    id: itemCompletedMouseArea
                    anchors.fill: parent
                    acceptedButtons: Qt.LeftButton

                    onPressed: {
                        //console.debug("ItemViewBasic onPressed itemCompletedMouseArea")

                        itemView.isSelected = true;
                        QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);

                        QtHandler.toggleCompletedForItem(itemView.itemUID)
                    }
                }
            }

            Image {
                id: itemRunstatusImage
                source: {
                    if (itemView.itemRunstatus == 1) return "qrc:/icons2/RunStatusPause10px.png"
                    if (itemView.itemRunstatus == 2) return "qrc:/icons2/RunStatusStop10px.png"
                    if (itemView.itemRunstatus == 3) return "qrc:/icons2/RunStatusCompleted10px.png"
                    else return "";
                }
                smooth: false

                visible: (itemView.itemRunstatus > 0)

                anchors.top: parent.top
                anchors.topMargin: 2
                anchors.left: parent.left
                anchors.leftMargin: 2
            }

            Rectangle {
                id: aidTag

                anchors.verticalCenter: parent.verticalCenter
                anchors.right: parent.right
                anchors.rightMargin: 3
                width: 11
                height: 12

                color: "#6d7783"

                visible: (itemView.itemAIDType >= 0)

                Text {
                    id: aidTagTitle
                    anchors.verticalCenter: parent.verticalCenter
                    anchors.horizontalCenter: parent.horizontalCenter

                    color: "white"
                    font.family: {
                        if (itemView.platform == "MAC") return "Helvetica Neue"
                        else return "Arial"
                    }
                    font.pixelSize: {
                        if (itemView.platform == "MAC") return 10
                        else return 7
                    }

                    text: {
                        if (itemView.itemAIDType == 1) return qsTr("I")
                        else if (itemView.itemAIDType == 2) return qsTr("D")
                        else return qsTr("A")
                    }
                }

                MouseArea {
                    id: itemAIDMouseArea
                    anchors.fill: parent
                    acceptedButtons: Qt.LeftButton

                    onPressed: {
                        //console.debug("ItemViewBasic onPressed itemAIDMouseArea")

                        if (!itemView.isSelected) {
                            itemView.isSelected = true;
                            QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                        }

                        //QtHandler.displayAIDPickerAt(aidTag.x + itemView.x, aidTag.y + itemView.top, itemView.itemUID)
                        QtHandler.displayAIDPickerAt(aidTag.x, aidTag.y, itemView.itemUID)
                    }
                }
            }

            Image {
                id: itemAttachmentImage
                source: "qrc:/icons2/AIDelegate/PreviewAttachmentIconMono14px.png"
                smooth: false

                anchors.verticalCenter: parent.verticalCenter
                anchors.right: aidTag.left
                anchors.rightMargin: 2

                visible: (itemView.itemAttachmentCount > 0)

                MouseArea {
                    id: itemAttachmentMouseArea
                    anchors.fill: parent
                    acceptedButtons: Qt.LeftButton

                    onPressed: {
                        //console.debug("ItemViewBasic onPressed itemAttachmentMouseArea")

                        if (!itemView.isSelected) {
                            itemView.isSelected = true;
                            QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                        }

                        QtHandler.goToAttachmentForItem(itemView.itemUID)
                    }
                }
            }

            Image {
                id: itemNoteImage
                source: "qrc:/icons2/AIDelegate/PreviewNoteIconMono14px.png"
                smooth: false

                anchors.verticalCenter: parent.verticalCenter
                anchors.right: {
                    if (itemAttachmentImage.visible) return itemAttachmentImage.left
                    else return aidTag.left
                }

                anchors.rightMargin: 2

                visible: (!itemView.layoutExpanded && itemView.itemHasNote > 0)

                MouseArea {
                    id: itemNoteMouseArea
                    anchors.fill: parent
                    acceptedButtons: Qt.LeftButton

                    onPressed: {
                        //console.debug("ItemViewBasic onPressed itemNoteMouseArea")

                        if (!itemView.isSelected) {
                            itemView.isSelected = true;
                            QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                        }

                        QtHandler.showCommentInspectorForItem(itemView.itemUID)
                    }
                }
            }

            Image {
                id: itemProgressImage
                source: {
                    if (itemView.itemProgress < 25) return "qrc:/icons2/AIDelegate/PreviewProgress00Mono14px.png"
                    else if (itemView.itemProgress < 50) return "qrc:/icons2/AIDelegate/PreviewProgress25Mono14px.png"
                    else if (itemView.itemProgress < 75) return "qrc:/icons2/AIDelegate/PreviewProgress50Mono14px.png"
                    else if (itemView.itemProgress < 100) return "qrc:/icons2/AIDelegate/PreviewProgress75Mono14px.png"
                    else return "qrc:/icons2/AIDelegate/PreviewProgress100Mono14px.png";
                }
                smooth: false

                anchors.verticalCenter: parent.verticalCenter
                anchors.right: {
                    if (itemNoteImage.visible) return itemNoteImage.left
                    else if (itemAttachmentImage.visible) return itemAttachmentImage.left
                    else return aidTag.left
                }

                anchors.rightMargin: 2

                visible: (!itemView.layoutExpanded && itemView.itemProgress > 0)
            }

            Text {
                id: itemDurationLabel
                text: itemView.itemDuration

                smooth: true

                anchors.verticalCenter: parent.verticalCenter
                anchors.right: {
                    if (itemProgressImage.visible) return itemProgressImage.left
                    else if (itemNoteImage.visible) return itemNoteImage.left
                    else if (itemAttachmentImage.visible) return itemAttachmentImage.left
                    else return aidTag.left
                }
                anchors.rightMargin: 2

                color: "#6d7783"
                font.family: {
                    if (itemView.platform == "MAC") return "Helvetica Neue"
                    else return "Arial"
                }
                font.pixelSize: {
                    if (itemView.platform == "MAC") return 10
                    else return 7
                }

                visible: (!itemView.layoutExpanded && itemView.itemDuration.length > 0)
            }

            ItemViewTextInput {
                id: itemTitleInput

                property string defaultText: ""

                visible: true
                enabled: true
                editable: itemView.isEditable
                text: itemView.itemTitle

                anchors.top: parent.top
                anchors.topMargin: 0
                anchors.left: itemCompletedImage.right
                anchors.leftMargin: {
                    if (itemCompletedImage.visible) return 25;
                    else return 2;
                }
                anchors.right: parent.right
                anchors.rightMargin: {
                    var baseMargin = 1
                    if (aidTag.visible) baseMargin += aidTag.width + 2
                    if (itemAttachmentImage.visible) baseMargin += itemAttachmentImage.width + 2
                    if (itemNoteImage.visible) baseMargin += itemNoteImage.width + 2
                    if (itemProgressImage.visible) baseMargin += itemProgressImage.width + 2
                    if (itemDurationLabel.visible) baseMargin += itemDurationLabel.width + 2
                    return baseMargin
                }
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2

                font.bold: false

                font.pixelSize: itemView.layoutFontSize
                font.family: itemView.layoutFontName
                font.weight: itemView.layoutFontWeight

                smooth: false
                textColor: {
                    if (itemView.itemType == "I") return "white";
                    if (itemView.itemType == "P") return "white";
                    if (itemView.itemType == "C") return "white";
                    return "#222222";
                }
                clip: true

                onTextChanged: {
                    itemView.isModified = true;
                }

                onEscapePressed: {
                    //                text = defaultText
                    //                deactivateControl()
                    endEdit(false)
                }

                onReturnPressed: {
                    //console.debug("Return pressed with " + defaultText)
                    //                if (defaultText !== text) {
                    //                    if (itemView.itemType === "") QtHandler.dataChanged(itemView.itemType, itemView.itemUID, "name", text)
                    //                    else QtHandler.dataChanged(itemView.itemType, itemView.itemProjectUID, "name", text)
                    //                }

                    //                deactivateControl()
                    //                itemView.isEditing = false
                    endEdit(true)
                }

                onFocusLost: {
                    //console.debug("Focus Lost with " + defaultText)
                    //                if (defaultText !== text) {
                    //                    if (itemView.itemType === "") QtHandler.dataChanged(itemView.itemType, itemView.itemUID, "name", text)
                    //                    else QtHandler.dataChanged(itemView.itemType, itemView.itemProjectUID, "name", text)
                    //                }

                    //                deactivateControl()

                    //                itemView.isEditing = false
                    endEdit(true)
                }

                onSelectReceived: {
                    //console.debug("Select Received with " + defaultText)
                    if (!itemView.isSelected) {
                        itemView.isSelected = true;

                        //                } else {
                        //                    if (editable) activateControl()
                        //                    itemView.isEditing = true
                    }

                    if (itemView.itemType === "") QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                    else QtHandler.selectionChanged(itemView.itemType, itemView.itemProjectUID, true);
                }

                onFocusReceived: {
                    //console.debug("Focus Received with " + defaultText)

                    //                if (itemView.itemType === "I") return;

                    itemView.isSelected = true;
                    //QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                    if (itemView.itemType === "") QtHandler.selectionChanged(itemView.itemType, itemView.itemUID, true);
                    else QtHandler.selectionChanged(itemView.itemType, itemView.itemProjectUID, true);

                    if (editable) {
                        activateControl(true)
                        itemView.isEditing = true
                    }
                }
            }
        }

        Rectangle {
            id: contentArea
            visible: itemView.layoutExpanded

            opacity: (itemView.itemCompleted) ? 0.7 : 1.0

            radius: itemView.backgroundRadius
            anchors.fill: parent
            anchors.topMargin: itemView.titleHeight - 1

            border.width: 1
            border.color: "black"

            smooth: false

            //
            // note section
            //

            Text {
                id: note
                anchors { left: parent.left; leftMargin: 3; bottom: parent.bottom; bottomMargin: (itemView.itemType === "") ? 37 : 2; right: parent.right; rightMargin: 3; top: parent.top; topMargin: 3; }

                wrapMode: Text.WordWrap
                clip: true
                smooth: true

                font.pixelSize: itemView.layoutNoteScaledFontSize
                font.family: itemView.layoutNoteFontName
                font.weight: itemView.layoutNoteFontWeight

                text: itemView.itemNote
            }

            Item {
                id: taskFooterSection

                anchors.fill: parent
                visible: (itemView.itemType === "")

                //
                // duration/progress section
                //

                Rectangle {
                    id: durationSegmentBorderTopLineRectangle

                    anchors { left: parent.left; leftMargin: (itemView.platform == "WIN") ? 0 : 1; bottom: parent.bottom; bottomMargin: 35; right: parent.right; rightMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 1

                    color: "transparent"

                    border.width: 1
                    border.color: {
                        if (itemView.itemType == "I") return background.color;
                        if (itemView.itemType == "P") return background.color;
                        if (itemView.itemType == "C") return background.color;
                        return "black";
                    }
                }

                Rectangle {
                    id: durationSegmentBorderMidLineRectangle1

                    anchors { left: parent.left; leftMargin: itemView.width / 2; bottom: parent.bottom; bottomMargin: 18; }
                    height: 17
                    width: 1

                    color: "transparent"

                    border.width: 1
                    //border.color: "blue"
                    border.color: durationSegmentBorderTopLineRectangle.border.color
                }

                Text {
                    id: durationHR
                    anchors { left: parent.left; leftMargin: 2; bottom: parent.bottom; bottomMargin: 18; }
                    height: 14
                    width: itemView.width / 2 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    text: itemView.itemDuration == "" ? "-" : itemView.itemDuration;
                }

                Text {
                    id: progressHR
                    anchors { right: parent.right; bottom: parent.bottom; bottomMargin: 18; }
                    height: 14
                    width: itemView.width / 2 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    text: itemView.itemProgress + " %";
                }

                //
                // date section
                //

                Rectangle {
                    id: dateSegmentBorderTopLineRectangle

                    anchors { left: parent.left; leftMargin: (itemView.platform == "WIN") ? 0 : 1; bottom: parent.bottom; bottomMargin: 18; right: parent.right; rightMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 1

                    color: "transparent"

                    border.width: 1
                    border.color: {
                        if (itemView.itemType == "I") return background.color;
                        if (itemView.itemType == "P") return background.color;
                        if (itemView.itemType == "C") return background.color;
                        return "black";
                    }
                }

                Rectangle {
                    id: dateSegmentBorderMidLineRectangle1

                    anchors { left: parent.left; leftMargin: itemView.width / 3; bottom: parent.bottom; bottomMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 17
                    width: 1

                    color: "transparent"

                    border.width: 1
                    //border.color: "blue"
                    border.color: dateSegmentBorderTopLineRectangle.border.color
                }

                Rectangle {
                    id: dateSegmentBorderMidLineRectangle2

                    anchors { right: parent.right; rightMargin: itemView.width / 3; bottom: parent.bottom; bottomMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 17
                    width: 1

                    color: "transparent"

                    border.width: 1
                    //border.color: "blue"
                    border.color: dateSegmentBorderTopLineRectangle.border.color
                }

                Text {
                    id: reviewDTSHR
                    anchors { left: parent.left; leftMargin: 2; bottom: parent.bottom; bottomMargin: 1; }
                    height: 14
                    width: itemView.width / 3 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    text: itemView.itemReviewDTS
                }

                Text {
                    id: startDTSHR
                    anchors { left: parent.left; leftMargin: itemView.width / 3; bottom: parent.bottom; bottomMargin: 1; }
                    height: 14
                    width: itemView.width / 3 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    text: itemView.itemStartDTS
                }

                Text {
                    id: endDTSHR
                    anchors { right: parent.right; bottom: parent.bottom; bottomMargin: 1; }
                    height: 14
                    width: itemView.width / 3 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    text: itemView.itemEndDTS
                }
            }

            Item {
                id: projectFooterSection

                anchors.fill: parent
                visible: (itemView.itemType !== "")

                //
                // date section
                //

                Rectangle {
                    id: pdateSegmentBorderTopLineRectangle

                    anchors { left: parent.left; leftMargin: (itemView.platform == "WIN") ? 0 : 1; bottom: parent.bottom; bottomMargin: 18; right: parent.right; rightMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 1

                    color: "transparent"

                    border.width: 1
                    border.color: {
                        //if (itemView.itemType == "P") return background.color;
                        return "black";
                    }
                }

                Rectangle {
                    id: pdateSegmentBorderMidLineRectangle1

                    anchors { left: parent.left; leftMargin: itemView.width / 2; bottom: parent.bottom; bottomMargin: (itemView.platform == "WIN") ? 0 : 1; }
                    height: 17
                    width: 1

                    color: "transparent"

                    border.width: 1
                    border.color: pdateSegmentBorderTopLineRectangle.border.color
                }

                Text {
                    id: pstartDTSHR
                    anchors { left: parent.left; leftMargin: 2; bottom: parent.bottom; bottomMargin: 1; }
                    height: 14
                    width: itemView.width / 2 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    color: "white"

                    text: itemView.itemStartDTS
                }

                Text {
                    id: pendDTSHR
                    anchors { right: parent.right; bottom: parent.bottom; bottomMargin: 1; }
                    height: 14
                    width: itemView.width / 2 - 2;

                    horizontalAlignment: Text.AlignHCenter
                    clip: true

                    font.pixelSize: itemView.layoutFooterScaledFontSize
                    font.family: itemView.layoutFooterFontName
                    font.weight: itemView.layoutFooterFontWeight

                    color: "white"

                    text: itemView.itemEndDTS
                }
            }

            MouseArea {
                id: contentMouseArea

                anchors.left: contentArea.left
                anchors.right: contentArea.right
                anchors.top: contentArea.top
                anchors.bottom: contentArea.bottom

                onDoubleClicked: {

                    if (itemView.itemType === "") QtHandler.showTaskInspector();
                    else QtHandler.showLibraryInspector();
                }
            }
        }


        Rectangle {
            id: selectionMarker
            color: "transparent"

            anchors.fill: widgetFrame

            smooth: false
            radius: itemView.backgroundRadius

            border.width: {
                if (itemView.isSelected) return 2
                return itemView.layoutBorderWidth
            }
            //            border.width: 2
            border.color: {
                if (itemView.isSelected) return "#4d9adf";
                if (itemView.itemType == "I") return background.color;
                if (itemView.itemType == "P") return background.color;
                if (itemView.itemType == "C") return background.color;
                return "transparent";
            }
        }
    }

}
